package cn.ibizlab.assetmanagement.core.apply.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.assetmanagement.core.apply.domain.EAMApplyType;
import cn.ibizlab.assetmanagement.core.apply.filter.EAMApplyTypeSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EAMApplyType] 服务对象接口
 */
public interface IEAMApplyTypeService extends IService<EAMApplyType>{

    boolean create(EAMApplyType et) ;
    void createBatch(List<EAMApplyType> list) ;
    boolean update(EAMApplyType et) ;
    void updateBatch(List<EAMApplyType> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    EAMApplyType get(String key) ;
    EAMApplyType getDraft(EAMApplyType et) ;
    boolean checkKey(EAMApplyType et) ;
    boolean save(EAMApplyType et) ;
    void saveBatch(List<EAMApplyType> list) ;
    Page<EAMApplyType> searchDefault(EAMApplyTypeSearchContext context) ;
    List<EAMApplyType> selectByEamapplystatemodelid(String eamapplystatemodelid) ;
    void removeByEamapplystatemodelid(String eamapplystatemodelid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<EAMApplyType> getEamapplytypeByIds(List<String> ids) ;
    List<EAMApplyType> getEamapplytypeByEntities(List<EAMApplyType> entities) ;
}


